<script lang="ts">
	import { onDestroy, onMount } from 'svelte';
	import { basePath, ws } from '$lib/config';
	import { crossfade } from 'svelte/transition';
	import type { Donor } from '$lib/donors';
	import { page } from '$app/stores';
	import { type Team, teams } from '$lib/teams';
	import { Howl, Howler } from 'howler';
	import ReconnectingWebSocket from 'reconnecting-websocket';

	const teamId = $page.url.searchParams.get('team');

	let displayedObj: Donor | null;

	let formatter = new Intl.NumberFormat('fr-FR', {
		style: 'currency',
		currency: 'EUR'
	});
	let snds = [
		new Howl({ src: [basePath() + 'assets/goal1.wav'] }),
		new Howl({ src: [basePath() + 'assets/goal2.wav'] }),
		new Howl({ src: [basePath() + 'assets/goal3.wav'] })
	];
	let largeSound = new Howl({ src: [basePath() + 'assets/Large.wav'] });

	let fifo: Donor[] = [];
	let fifoRunning: number | null;

	let timeout: number = 0;

	let nameLetters: string[];
	let text1Letters: string[] = 'a donné'.split('');
	let amountLetters: string[];

	// Quand tu recois un message tu le append dans fifo :
	function receiveDon(don: Donor) {
		fifo.push(don);
		runFifo();
	}

	function runFifo() {
		if (fifoRunning) return;
		fifoRunning = setInterval(doSomething, 100);
	}

	function doSomething() {
		// Ce que tu dois faire avec le dernier
		if (!timeout) {
			let don = fifo.shift();
			if (don) {
				displayedObj = null;
				text1Letters = [];
				nameLetters = [];
				amountLetters = [];
				setTimeout(() => {
					let duration = 5000;
					if (don) {
						don = don;
						console.log(don);

						if (don.amount >= 20000) {
							largeSound.play();
							duration = 13500;
						} else {
							let x = Math.floor(Math.random() * 3);
							snds[x].play();
							duration = 5000;
						}
						displayedObj = don;
						text1Letters = 'a donné'.split('');
						amountLetters = formatter.format(displayedObj.amount / 100).split('');
						nameLetters = (displayedObj.first_name + ' ' + displayedObj.last_name).split('');
					}
					timeout = setTimeout(() => {
						displayedObj = null;
						nameLetters = [];
						text1Letters = [];
						amountLetters = [];
						timeout = 0;
					}, duration);
				}, 2);
			}

			if (fifo.length === 0 && fifoRunning) {
				clearInterval(fifoRunning);
				fifoRunning = null;
			}
		}
	}

	onMount(async () => {
		// Start WS
		const socket = new ReconnectingWebSocket(ws());

		socket.addEventListener('open', function (event) {
			socket.send(JSON.stringify({ op: 'sub', msg: `teams.${teamId}.don` }));
		});

		socket.addEventListener('message', function (event) {
			let data = JSON.parse(event.data);
			switch (data.r) {
				case `teams.${teamId}.don`:
					receiveDon(data.d.don);
					break;
				case `refresh`:
					// Refresh the page
					setTimeout(() => {
						window.location.reload();
					}, Math.random() * 1000);
					break;
			}
		});
	});

	onDestroy(() => {
		if (fifoRunning) {
			clearInterval(fifoRunning);
		}
	});
</script>

<div class="color flex flex-col w-screen h-screen items-center justify-center absolute top-0 -z-10">
	<div class="self-center">
		<div class="flex flex-col items-center text-7xl font-extrabold -mt-20">
			{#if displayedObj}
				<div class="flex flex-row gap-1" style="background-color:transparent">
					<div class="flex flex-row">
						{#each nameLetters as letter, i}
							<div class="important-text letter-wave" style:--i={i}>
								{#if /\s/.test(letter)}
									<div class="empty"></div>
								{:else}
									{letter}
								{/if}
							</div>
						{/each}
					</div>
					<div class="flex flex-row">
						{#each text1Letters as letter, i}
							<div class="regular-text letter-wave" style:--i={i + nameLetters.length}>
								{#if /\s/.test(letter)}
									<div class="empty"></div>
								{:else}
									{letter}
								{/if}
							</div>
						{/each}
					</div>
					<div class="flex flex-row">
						{#each amountLetters as letter, i}
							<div
								class="important-text letter-wave"
								style:--i={i + nameLetters.length + text1Letters.length}
							>
								{#if /\s/.test(letter)}
									<div class="empty"></div>
								{:else}
									{letter}
								{/if}
							</div>
						{/each}
					</div>
				</div>
			{/if}
		</div>
	</div>
</div>

<style>
	.important-text {
		color: orange;
		font-size: 44px;
	}
	.regular-text {
		color: white;
		font-size: 40px;
		-webkit-text-stroke-width: 1px;
		-webkit-text-stroke-color: black;
	}
	.empty {
		content: ' ';
		width: 5px;
	}

	.letter-wave {
		animation: waviy 3s infinite;
		animation-delay: calc(0.05s * var(--i));
	}
	@keyframes waviy {
		0% {
			transform: translateY(5px);
		}
		50% {
			transform: translateY(-10px);
		}
		100% {
			transform: translateY(5px);
		}
	}
</style>
